<?php
/**
 * script de calcul de la conso elec
 *
 * @author Guillaume DESNOUES
 * @license http://opensource.org/licenses/GPL-3.0 GPL-3.0
 * @copyright 2015 The Authors
 *
 * V0.1
 *	+ code initial
 */

/* ----- definition des codes API ----- */
$CodeAPI = array (
	'HistoA' => 'xxxxxx',
	'HistoM' => 'xxxxxx',
	'HistoS' => 'xxxxxx',
	'HistoJ' => 'xxxxxx',
	'ActuHC' => 'xxxxxx',
	'ActuHP' => 'xxxxxx'
);
$Prix['HC'] = '0.1039';
$Prix['HP'] = '0.1505';


/* ----- ne plus modifier a partir d'ici ----- */
$Debug = false; //mettre  true pour debug des tableaux sinon laisser false
$Step = getArg('step', $mandatory = true, $default = ''); // recuperation de la variable $_GET[]

/* ----- recuperation des valeurs ----- */
$TablHistoA = getValue($CodeAPI['HistoA']);
$TablHistoM = getValue($CodeAPI['HistoM']);
$TablHistoS = getValue($CodeAPI['HistoS']);
$TablHistoJ = getValue($CodeAPI['HistoJ']);
$TablActuHC = getValue($CodeAPI['ActuHC']);
$TablActuHP = getValue($CodeAPI['ActuHP']);

$ExplodeHistoA = explode("|", $TablHistoA['value']);
$ExplodeHistoM = explode("|", $TablHistoM['value']);
$ExplodeHistoS = explode("|", $TablHistoS['value']);
$ExplodeHistoJ = explode("|", $TablHistoJ['value']);

$Val = array (
	'A_HC' => $ExplodeHistoA[0],
	'A_HP' => $ExplodeHistoA[1],
	'M_HC' => $ExplodeHistoM[0],
	'M_HP' => $ExplodeHistoM[1],
	'S_HC' => $ExplodeHistoS[0],
	'S_HP' => $ExplodeHistoS[1],
	'J_HC' => $ExplodeHistoJ[0],
	'J_HP' => $ExplodeHistoJ[1],
	'Actu_HC' => $TablActuHC['value'],
	'Actu_HP' => $TablActuHP['value']
);
if ($Debug) {
	echo "Tableau \$Val:<br />";
	echo '<pre>';
	var_dump($Val);
	echo '</pre>';
}

/* ----- update des compteurs de la box ----- */
if ($Step === 'update') {
	
	if (date("dm") === '3112') {
		setValue($CodeAPI['HistoA'], $Val['Actu_HC'].'|'.$Val['Actu_HP'], false); //maj de HistoA car on est le 31/12
	}
	if (date("d") === date('t')) {
		setValue($CodeAPI['HistoM'], $Val['Actu_HC'].'|'.$Val['Actu_HP'], false); //maj de HistoM car on est le dernier jour du mois		
	}
	if (date("w") === '0') {
		setValue($CodeAPI['HistoS'], $Val['Actu_HC'].'|'.$Val['Actu_HP'], false); //maj de HistoS car on est dimanche
	}
	setValue($CodeAPI['HistoJ'], $Val['Actu_HC'].'|'.$Val['Actu_HP'], false); //maj de HistoJ
}

/* ----- calcul des conso ----- */
if ($Step === 'read') {
	$arr = array('A', 'M', 'S', 'J');
	$Result = array();
	foreach ($arr as $value) {
		$Result[$value.'_HC'] = $Val['Actu_HC']-$Val[$value.'_HC'];
		$Result[$value.'_HC'] = $Result[$value.'_HC']/1000;
		$Result[$value.'_HP'] = $Val['Actu_HP']-$Val[$value.'_HP'];
		$Result[$value.'_HP'] = $Result[$value.'_HP']/1000;
		$Result[$value.'_PrixHC'] = $Result[$value.'_HC']*$Prix['HC'];
		$Result[$value.'_PrixHP'] = $Result[$value.'_HP']*$Prix['HP'];
		$Result[$value.'_PrixTotal'] = $Result[$value.'_PrixHC']+$Result[$value.'_PrixHP'];   
	}
	
	/* ----- Affichage ----- */
	if ($Debug) {
		echo "Tableau \$Result:<br />";
		echo '<pre>';
		var_dump($Result);
		echo '</pre>';
	}
	
	echo "<h1>consommation electrique</h1>";
	
	echo "<hr /><u>index actuel :</u><br />";
	echo "&nbsp;&nbsp;"."HC = ".$Val['Actu_HC']." Wh"."<br />";
	echo "&nbsp;&nbsp;"."HP = ".$Val['Actu_HP']." Wh";
	
	echo "<hr /><u>conso journalire :</u><br />";
	echo "&nbsp;&nbsp;"."HC = ".$Result['J_HC']." KWh"."<br />";
	echo "&nbsp;&nbsp;"."HP = ".$Result['J_HP']." KWh"."<br />";
	echo "&nbsp;&nbsp;"."Prix HC = ".round($Result['J_PrixHC'],2)." "."<br />";
	echo "&nbsp;&nbsp;"."Prix HP = ".round($Result['J_PrixHP'],2)." "."<br />";
	echo "&nbsp;&nbsp;"."<b>"."Prix Total = ".round($Result['J_PrixTotal'],2)." "."</b>";
	
	echo "<hr /><u>conso hebdomadaire :</u><br />";
	echo "&nbsp;&nbsp;"."HC = ".$Result['S_HC']." KWh"."<br />";
	echo "&nbsp;&nbsp;"."HP = ".$Result['S_HP']." KWh"."<br />";
	echo "&nbsp;&nbsp;"."Prix HC = ".round($Result['S_PrixHC'],2)." "."<br />";
	echo "&nbsp;&nbsp;"."Prix HP = ".round($Result['S_PrixHP'],2)." "."<br />";
	echo "&nbsp;&nbsp;"."<b>"."Prix Total = ".round($Result['S_PrixTotal'],2)." "."</b>";
	
	echo "<hr /><u>conso mensuelle :</u><br />";
	echo "&nbsp;&nbsp;"."HC = ".$Result['M_HC']." KWh"."<br />";
	echo "&nbsp;&nbsp;"."HP = ".$Result['M_HP']." KWh"."<br />";
	echo "&nbsp;&nbsp;"."Prix HC = ".round($Result['M_PrixHC'],2)." "."<br />";
	echo "&nbsp;&nbsp;"."Prix HP = ".round($Result['M_PrixHP'],2)." "."<br />";
	echo "&nbsp;&nbsp;"."<b>"."Prix Total = ".round($Result['M_PrixTotal'],2)." "."</b>";
	
	echo "<hr /><u>conso annuelle :</u><br />";
	echo "&nbsp;&nbsp;"."HC = ".$Result['A_HC']." KWh"."<br />";
	echo "&nbsp;&nbsp;"."HP = ".$Result['A_HP']." KWh"."<br />";
	echo "&nbsp;&nbsp;"."Prix HC = ".round($Result['A_PrixHC'],2)." "."<br />";
	echo "&nbsp;&nbsp;"."Prix HP = ".round($Result['A_PrixHP'],2)." "."<br />";
	echo "&nbsp;&nbsp;"."<b>"."Prix Total = ".round($Result['A_PrixTotal'],2)." "."</b>";
}

/* ----- autre action futur ----- */
?>